// ==========================================================
// 1_選單
// 2_Section Anchor 導航列置頂
// 3_輪播頁簽
// 4_專案介紹 - 閱讀更多 
// 5_Q&A收合
// 6_Action button & referral code
// ==========================================================




// ==========================================================
// 1_選單
// ==========================================================
    const header = document.querySelector('.header');
    const navbartoggler = document.querySelector('.navbar-toggler');

    navbartoggler.addEventListener('click',function(e){
        e.preventDefault();
        if (header.classList.contains('open')) {
            header.classList.remove('open');
            document.documentElement.style.overflowY = "initial";
        } else {
            header.classList.add('open');
            document.documentElement.style.overflowY = "hidden";
        }
    }, false);



// ==========================================================
// 2_Section Anchor 導航列置頂
// ==========================================================
    let headerHeight = header.offsetHeight;
    let sectionAnchor = document.querySelector('.section_anchor');
    let anchorLinks = document.querySelectorAll('.anchor_link');
    if (typeof(sectionAnchor) != 'undefined' && sectionAnchor != null){
        checkSectionAnchor(sectionAnchor);
        document.addEventListener('scroll', function(e) {
            checkSectionAnchor(sectionAnchor);
        });
    }

    function checkSectionAnchor(sectionAnchor){
        let anchorArray = sectionAnchor.querySelectorAll('.anchor_link');
        if (anchorArray.length > 0) {
            let anchorTopArray = [];
            anchorArray.forEach(item => {
                let targetAnchor = item.getAttribute('href').replace('#', '');
                let targetAnchorTop = document.getElementById(targetAnchor).offsetTop - sectionAnchor.offsetHeight - headerHeight;
                anchorTopArray.push(targetAnchorTop);
            });
            let sectionAnchorY = anchorTopArray[0] + sectionAnchor.offsetHeight + headerHeight;
            if (window.scrollY >= sectionAnchorY - headerHeight){
                sectionAnchor.classList.add('active');
                sectionAnchor.style.top = headerHeight + 'px';
            } else {
                sectionAnchor.removeAttribute('style');
                sectionAnchor.classList.remove('active');
                anchorLinks.forEach(item => item.parentElement.classList.remove('active'));
                anchorLinks[0].parentElement.classList.add('active');
            }
            
            anchorTopArray.forEach((item, index) => {
                if (window.scrollY >= item){
                    anchorLinks.forEach(item => item.parentElement.classList.remove('active'));
                    anchorLinks[index].parentElement.classList.add('active');
                }
            });
        }
    }

    if (anchorLinks.length > 0){
        anchorLinks.forEach(item => item.addEventListener('click', function(e){
            // e.preventDefault();
            anchorLinks.forEach(item => item.parentElement.classList.remove('active'));
            e.target.parentElement.classList.add('active');
            let targetAnchor = e.target.getAttribute('href').replace('#', '');
            let targetAnchorTop = document.getElementById(targetAnchor).offsetTop - sectionAnchor.offsetHeight;
            if(sectionAnchor.classList.contains('active')){
                targetAnchorTop = document.getElementById(targetAnchor).offsetTop;
            }
            window.scroll({
                top: targetAnchorTop,
                behavior: 'smooth'
              });
        }));
    }



// ==========================================================
// 3_輪播頁簽
// ==========================================================

    const groupTablinks = document.querySelectorAll('.tab_link');
    const groupItems = document.querySelectorAll('.group_step');
    groupTablinks.forEach(item => item.addEventListener('click', function(e){
        let targetCarousel =  e.target.getAttribute("data-carousel");
        groupTablinks.forEach(item => item.classList.remove('active'));
        e.target.classList.add('active');
        groupItems.forEach(item => item.classList.remove('active'));
        document.getElementById(targetCarousel).classList.add('active');
    }))




// ==========================================================
// 4_專案介紹 - 閱讀更多
// ==========================================================
    const readmore = document.querySelector('.readmore');
    const readmorelink = document.querySelector('.readmore a');
    const hidetxtList = document.querySelectorAll('.hidetxt');

    if (typeof(readmorelink) != 'undefined' && readmorelink != null){
        readmorelink.addEventListener('click', function(e){
            e.preventDefault();
            hidetxtList.forEach(item => item.classList.remove('hidetxt'));
            readmore.classList.add('hidetxt');
        }, false);
    }
    



// ==========================================================
// 5_Q&A收合
// ==========================================================
    const qaboxtitlebuttons = document.querySelectorAll('.qa-box-title');
    qaboxtitlebuttons.forEach(item => item.addEventListener('click', function(e){
        e.preventDefault();
        if (this.classList.contains('open')){
            this.classList.remove('open');
        } else {
            const qaboxtitleOpen = document.querySelectorAll('.qa-box-title.open');
            qaboxtitleOpen.forEach(item => item.classList.remove('open'));
            this.classList.add('open');
            window.scrollTo({
                top: getPosition(this).y - navHeight,
                behavior: 'smooth'
            });
        }
    }, false));

    const qaitembuttons = document.querySelectorAll('.qa-item .qa-title-image');
    qaitembuttons.forEach(item => item.addEventListener('click', function(e){
        e.preventDefault();
        const qaitemSelected = e.target.parentNode.parentNode.parentNode;
        if (qaitemSelected.classList.contains('open')){
            qaitemSelected.classList.remove('open');    
        } else {
            // const qaitemOpen = document.querySelectorAll('.qa-item.open');
            // qaitemOpen.forEach(item => item.classList.remove('open'));
            qaitemSelected.classList.add('open');
            // window.scrollTo({
            //     top: getPosition(e.target).y - navHeight,
            //     behavior: 'smooth'
            // });
        }
    }, false));




// ==========================================================
// 6_Action button & referral code
// ==========================================================
    // 導向到連結時會附加到導向網站URL的資料（Query String）
    // 如：設定為whiteList=['anchor', 'referralCode']，並在打開的HTML網址後加入?referralCode=xxx&anchor=xxx
    // 就會在導引到給定連結https://internet-banking.dbs.com.tw/dao?prodOption=3&step=0&referralCode=xxx&anchor=xxx
    // 除了anchor和referralCode的其他資料就不會帶入
    let whiteList = ['referralCode','cid'];

    document.querySelectorAll('a[data-bind-q-str]').forEach(elem => elem.addEventListener('click', function(e){
        e.preventDefault();
        redirectToInternetBank(this);
    }, false));

    function redirectToInternetBank(e) {
        let url = e.getAttribute('href');
        location.search.trim().replace(/^[?#&]/, '').split('&').forEach(function(str) {
            let entry = str.split('=');
            if (whiteList.indexOf(entry[0]) > -1) {
                let sep = url.indexOf('?') > -1 ? '&' : '?';
                url += (sep + entry[0] + '=' + entry[1]);
            }
        });
        location.assign(url);
    }

    function getPosition(el) {
        var xPosition = 0;
        var yPosition = 0;
       
        while (el) {
          if (el.tagName == 'body') {
            // deal with browser quirks with body/window/document and page scroll
            var xScrollPos = el.scrollLeft || document.documentElement.scrollLeft;
            var yScrollPos = el.scrollTop || document.documentElement.scrollTop;
       
            xPosition += (el.offsetLeft - xScrollPos + el.clientLeft);
            yPosition += (el.offsetTop - yScrollPos + el.clientTop);
          } else {
            xPosition += (el.offsetLeft - el.scrollLeft + el.clientLeft);
            yPosition += (el.offsetTop - el.scrollTop + el.clientTop);
          }
       
          el = el.offsetParent;
        }
        return {
          x: xPosition,
          y: yPosition
        };
      }



